<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfETTicketTarget ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfETTicketTarget
 * @subpackage Arrays
 */
class ArrayOfETTicketTarget extends AbstractStructArrayBase
{
    /**
     * The ETTicketTarget
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\ETTicketTarget[]
     */
    public $ETTicketTarget;
    /**
     * Constructor method for ArrayOfETTicketTarget
     * @uses ArrayOfETTicketTarget::setETTicketTarget()
     * @param \App|C\StructType\ETTicketTarget[] $eTTicketTarget
     */
    public function __construct(array $eTTicketTarget = array())
    {
        $this
            ->setETTicketTarget($eTTicketTarget);
    }
    /**
     * Get ETTicketTarget value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\ETTicketTarget[]|null
     */
    public function getETTicketTarget()
    {
        return isset($this->ETTicketTarget) ? $this->ETTicketTarget : null;
    }
    /**
     * This method is responsible for validating the values passed to the setETTicketTarget method
     * This method is willingly generated in order to preserve the one-line inline validation within the setETTicketTarget method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateETTicketTargetForArrayConstraintsFromSetETTicketTarget(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfETTicketTargetETTicketTargetItem) {
            // validation for constraint: itemType
            if (!$arrayOfETTicketTargetETTicketTargetItem instanceof \App|C\StructType\ETTicketTarget) {
                $invalidValues[] = is_object($arrayOfETTicketTargetETTicketTargetItem) ? get_class($arrayOfETTicketTargetETTicketTargetItem) : sprintf('%s(%s)', gettype($arrayOfETTicketTargetETTicketTargetItem), var_export($arrayOfETTicketTargetETTicketTargetItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ETTicketTarget property can only contain items of type \App|C\StructType\ETTicketTarget, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ETTicketTarget value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicketTarget[] $eTTicketTarget
     * @return \App|C\ArrayType\ArrayOfETTicketTarget
     */
    public function setETTicketTarget(array $eTTicketTarget = array())
    {
        // validation for constraint: array
        if ('' !== ($eTTicketTargetArrayErrorMessage = self::validateETTicketTargetForArrayConstraintsFromSetETTicketTarget($eTTicketTarget))) {
            throw new \InvalidArgumentException($eTTicketTargetArrayErrorMessage, __LINE__);
        }
        if (is_null($eTTicketTarget) || (is_array($eTTicketTarget) && empty($eTTicketTarget))) {
            unset($this->ETTicketTarget);
        } else {
            $this->ETTicketTarget = $eTTicketTarget;
        }
        return $this;
    }
    /**
     * Add item to ETTicketTarget value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\ETTicketTarget $item
     * @return \App|C\ArrayType\ArrayOfETTicketTarget
     */
    public function addToETTicketTarget(\App|C\StructType\ETTicketTarget $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\ETTicketTarget) {
            throw new \InvalidArgumentException(sprintf('The ETTicketTarget property can only contain items of type \App|C\StructType\ETTicketTarget, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ETTicketTarget[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\ETTicketTarget|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\ETTicketTarget|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\ETTicketTarget|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\ETTicketTarget|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\ETTicketTarget|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ETTicketTarget
     */
    public function getAttributeName()
    {
        return 'ETTicketTarget';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\ArrayType\ArrayOfETTicketTarget
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
