<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AbstractTicketFare StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:AbstractTicketFare
 * @subpackage Structs
 */
class AbstractTicketFare extends AbstractFareOfTicketAmountDetails48VTEFp2
{
    /**
     * The CreatedDateGMT
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CreatedDateGMT;
    /**
     * The Ref
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Ref;
    /**
     * The RefItinerary
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RefItinerary;
    /**
     * Constructor method for AbstractTicketFare
     * @uses AbstractTicketFare::setCreatedDateGMT()
     * @uses AbstractTicketFare::setRef()
     * @uses AbstractTicketFare::setRefItinerary()
     * @param string $createdDateGMT
     * @param string $ref
     * @param string $refItinerary
     */
    public function __construct($createdDateGMT = null, $ref = null, $refItinerary = null)
    {
        $this
            ->setCreatedDateGMT($createdDateGMT)
            ->setRef($ref)
            ->setRefItinerary($refItinerary);
    }
    /**
     * Get CreatedDateGMT value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCreatedDateGMT()
    {
        return isset($this->CreatedDateGMT) ? $this->CreatedDateGMT : null;
    }
    /**
     * Set CreatedDateGMT value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $createdDateGMT
     * @return \App|C\StructType\AbstractTicketFare
     */
    public function setCreatedDateGMT($createdDateGMT = null)
    {
        // validation for constraint: string
        if (!is_null($createdDateGMT) && !is_string($createdDateGMT)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdDateGMT, true), gettype($createdDateGMT)), __LINE__);
        }
        if (is_null($createdDateGMT) || (is_array($createdDateGMT) && empty($createdDateGMT))) {
            unset($this->CreatedDateGMT);
        } else {
            $this->CreatedDateGMT = $createdDateGMT;
        }
        return $this;
    }
    /**
     * Get Ref value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRef()
    {
        return isset($this->Ref) ? $this->Ref : null;
    }
    /**
     * Set Ref value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $ref
     * @return \App|C\StructType\AbstractTicketFare
     */
    public function setRef($ref = null)
    {
        // validation for constraint: string
        if (!is_null($ref) && !is_string($ref)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ref, true), gettype($ref)), __LINE__);
        }
        if (is_null($ref) || (is_array($ref) && empty($ref))) {
            unset($this->Ref);
        } else {
            $this->Ref = $ref;
        }
        return $this;
    }
    /**
     * Get RefItinerary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRefItinerary()
    {
        return isset($this->RefItinerary) ? $this->RefItinerary : null;
    }
    /**
     * Set RefItinerary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $refItinerary
     * @return \App|C\StructType\AbstractTicketFare
     */
    public function setRefItinerary($refItinerary = null)
    {
        // validation for constraint: string
        if (!is_null($refItinerary) && !is_string($refItinerary)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refItinerary, true), gettype($refItinerary)), __LINE__);
        }
        if (is_null($refItinerary) || (is_array($refItinerary) && empty($refItinerary))) {
            unset($this->RefItinerary);
        } else {
            $this->RefItinerary = $refItinerary;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\AbstractTicketFare
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
