<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareInfoEMD StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FareInfoEMD
 * @subpackage Structs
 */
class FareInfoEMD extends FareInfoOptions
{
    /**
     * The EMDTicketFares
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfEMDTicketFare
     */
    public $EMDTicketFares;
    /**
     * The SaleCurrencyAmountTotal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Amount
     */
    public $SaleCurrencyAmountTotal;
    /**
     * Constructor method for FareInfoEMD
     * @uses FareInfoEMD::setEMDTicketFares()
     * @uses FareInfoEMD::setSaleCurrencyAmountTotal()
     * @param \App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares
     * @param \App|C\StructType\Amount $saleCurrencyAmountTotal
     */
    public function __construct(\App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares = null, \App|C\StructType\Amount $saleCurrencyAmountTotal = null)
    {
        $this
            ->setEMDTicketFares($eMDTicketFares)
            ->setSaleCurrencyAmountTotal($saleCurrencyAmountTotal);
    }
    /**
     * Get EMDTicketFares value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfEMDTicketFare|null
     */
    public function getEMDTicketFares()
    {
        return isset($this->EMDTicketFares) ? $this->EMDTicketFares : null;
    }
    /**
     * Set EMDTicketFares value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares
     * @return \App|C\StructType\FareInfoEMD
     */
    public function setEMDTicketFares(\App|C\ArrayType\ArrayOfEMDTicketFare $eMDTicketFares = null)
    {
        if (is_null($eMDTicketFares) || (is_array($eMDTicketFares) && empty($eMDTicketFares))) {
            unset($this->EMDTicketFares);
        } else {
            $this->EMDTicketFares = $eMDTicketFares;
        }
        return $this;
    }
    /**
     * Get SaleCurrencyAmountTotal value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Amount|null
     */
    public function getSaleCurrencyAmountTotal()
    {
        return isset($this->SaleCurrencyAmountTotal) ? $this->SaleCurrencyAmountTotal : null;
    }
    /**
     * Set SaleCurrencyAmountTotal value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Amount $saleCurrencyAmountTotal
     * @return \App|C\StructType\FareInfoEMD
     */
    public function setSaleCurrencyAmountTotal(\App|C\StructType\Amount $saleCurrencyAmountTotal = null)
    {
        if (is_null($saleCurrencyAmountTotal) || (is_array($saleCurrencyAmountTotal) && empty($saleCurrencyAmountTotal))) {
            unset($this->SaleCurrencyAmountTotal);
        } else {
            $this->SaleCurrencyAmountTotal = $saleCurrencyAmountTotal;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FareInfoEMD
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
