<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FaultReplayInfo StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FaultReplayInfo
 * @subpackage Structs
 */
class FaultReplayInfo extends AbstractStructBase
{
    /**
     * The AppDomainName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AppDomainName;
    /**
     * The ApplicationName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ApplicationName;
    /**
     * The Context
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\MessageContext
     */
    public $Context;
    /**
     * The IdConfiguration
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $IdConfiguration;
    /**
     * The Input
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Input;
    /**
     * The MachineName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MachineName;
    /**
     * The MethodName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $MethodName;
    /**
     * The ProcessName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ProcessName;
    /**
     * The ServiceName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ServiceName;
    /**
     * The Url
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Url;
    /**
     * Constructor method for FaultReplayInfo
     * @uses FaultReplayInfo::setAppDomainName()
     * @uses FaultReplayInfo::setApplicationName()
     * @uses FaultReplayInfo::setContext()
     * @uses FaultReplayInfo::setIdConfiguration()
     * @uses FaultReplayInfo::setInput()
     * @uses FaultReplayInfo::setMachineName()
     * @uses FaultReplayInfo::setMethodName()
     * @uses FaultReplayInfo::setProcessName()
     * @uses FaultReplayInfo::setServiceName()
     * @uses FaultReplayInfo::setUrl()
     * @param string $appDomainName
     * @param string $applicationName
     * @param \App|C\StructType\MessageContext $context
     * @param int $idConfiguration
     * @param string $input
     * @param string $machineName
     * @param string $methodName
     * @param string $processName
     * @param string $serviceName
     * @param string $url
     */
    public function __construct($appDomainName = null, $applicationName = null, \App|C\StructType\MessageContext $context = null, $idConfiguration = null, $input = null, $machineName = null, $methodName = null, $processName = null, $serviceName = null, $url = null)
    {
        $this
            ->setAppDomainName($appDomainName)
            ->setApplicationName($applicationName)
            ->setContext($context)
            ->setIdConfiguration($idConfiguration)
            ->setInput($input)
            ->setMachineName($machineName)
            ->setMethodName($methodName)
            ->setProcessName($processName)
            ->setServiceName($serviceName)
            ->setUrl($url);
    }
    /**
     * Get AppDomainName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAppDomainName()
    {
        return isset($this->AppDomainName) ? $this->AppDomainName : null;
    }
    /**
     * Set AppDomainName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $appDomainName
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setAppDomainName($appDomainName = null)
    {
        // validation for constraint: string
        if (!is_null($appDomainName) && !is_string($appDomainName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($appDomainName, true), gettype($appDomainName)), __LINE__);
        }
        if (is_null($appDomainName) || (is_array($appDomainName) && empty($appDomainName))) {
            unset($this->AppDomainName);
        } else {
            $this->AppDomainName = $appDomainName;
        }
        return $this;
    }
    /**
     * Get ApplicationName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getApplicationName()
    {
        return isset($this->ApplicationName) ? $this->ApplicationName : null;
    }
    /**
     * Set ApplicationName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $applicationName
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setApplicationName($applicationName = null)
    {
        // validation for constraint: string
        if (!is_null($applicationName) && !is_string($applicationName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($applicationName, true), gettype($applicationName)), __LINE__);
        }
        if (is_null($applicationName) || (is_array($applicationName) && empty($applicationName))) {
            unset($this->ApplicationName);
        } else {
            $this->ApplicationName = $applicationName;
        }
        return $this;
    }
    /**
     * Get Context value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\MessageContext|null
     */
    public function getContext()
    {
        return isset($this->Context) ? $this->Context : null;
    }
    /**
     * Set Context value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\MessageContext $context
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setContext(\App|C\StructType\MessageContext $context = null)
    {
        if (is_null($context) || (is_array($context) && empty($context))) {
            unset($this->Context);
        } else {
            $this->Context = $context;
        }
        return $this;
    }
    /**
     * Get IdConfiguration value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getIdConfiguration()
    {
        return isset($this->IdConfiguration) ? $this->IdConfiguration : null;
    }
    /**
     * Set IdConfiguration value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $idConfiguration
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setIdConfiguration($idConfiguration = null)
    {
        // validation for constraint: int
        if (!is_null($idConfiguration) && !(is_int($idConfiguration) || ctype_digit($idConfiguration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idConfiguration, true), gettype($idConfiguration)), __LINE__);
        }
        if (is_null($idConfiguration) || (is_array($idConfiguration) && empty($idConfiguration))) {
            unset($this->IdConfiguration);
        } else {
            $this->IdConfiguration = $idConfiguration;
        }
        return $this;
    }
    /**
     * Get Input value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInput()
    {
        return isset($this->Input) ? $this->Input : null;
    }
    /**
     * Set Input value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $input
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setInput($input = null)
    {
        // validation for constraint: string
        if (!is_null($input) && !is_string($input)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($input, true), gettype($input)), __LINE__);
        }
        if (is_null($input) || (is_array($input) && empty($input))) {
            unset($this->Input);
        } else {
            $this->Input = $input;
        }
        return $this;
    }
    /**
     * Get MachineName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMachineName()
    {
        return isset($this->MachineName) ? $this->MachineName : null;
    }
    /**
     * Set MachineName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $machineName
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setMachineName($machineName = null)
    {
        // validation for constraint: string
        if (!is_null($machineName) && !is_string($machineName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($machineName, true), gettype($machineName)), __LINE__);
        }
        if (is_null($machineName) || (is_array($machineName) && empty($machineName))) {
            unset($this->MachineName);
        } else {
            $this->MachineName = $machineName;
        }
        return $this;
    }
    /**
     * Get MethodName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMethodName()
    {
        return isset($this->MethodName) ? $this->MethodName : null;
    }
    /**
     * Set MethodName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $methodName
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setMethodName($methodName = null)
    {
        // validation for constraint: string
        if (!is_null($methodName) && !is_string($methodName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($methodName, true), gettype($methodName)), __LINE__);
        }
        if (is_null($methodName) || (is_array($methodName) && empty($methodName))) {
            unset($this->MethodName);
        } else {
            $this->MethodName = $methodName;
        }
        return $this;
    }
    /**
     * Get ProcessName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProcessName()
    {
        return isset($this->ProcessName) ? $this->ProcessName : null;
    }
    /**
     * Set ProcessName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $processName
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setProcessName($processName = null)
    {
        // validation for constraint: string
        if (!is_null($processName) && !is_string($processName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($processName, true), gettype($processName)), __LINE__);
        }
        if (is_null($processName) || (is_array($processName) && empty($processName))) {
            unset($this->ProcessName);
        } else {
            $this->ProcessName = $processName;
        }
        return $this;
    }
    /**
     * Get ServiceName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getServiceName()
    {
        return isset($this->ServiceName) ? $this->ServiceName : null;
    }
    /**
     * Set ServiceName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serviceName
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setServiceName($serviceName = null)
    {
        // validation for constraint: string
        if (!is_null($serviceName) && !is_string($serviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serviceName, true), gettype($serviceName)), __LINE__);
        }
        if (is_null($serviceName) || (is_array($serviceName) && empty($serviceName))) {
            unset($this->ServiceName);
        } else {
            $this->ServiceName = $serviceName;
        }
        return $this;
    }
    /**
     * Get Url value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUrl()
    {
        return isset($this->Url) ? $this->Url : null;
    }
    /**
     * Set Url value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $url
     * @return \App|C\StructType\FaultReplayInfo
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($url, true), gettype($url)), __LINE__);
        }
        if (is_null($url) || (is_array($url) && empty($url))) {
            unset($this->Url);
        } else {
            $this->Url = $url;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\FaultReplayInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
