<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MessageIdentity StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MessageIdentity
 * @subpackage Structs
 */
class MessageIdentity extends AbstractStructBase
{
    /**
     * The IdCompany
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $IdCompany;
    /**
     * The IdUser
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $IdUser;
    /**
     * The IdPos
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $IdPos;
    /**
     * The IdCustomer
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $IdCustomer;
    /**
     * The _x003C_IdCompany_x003E_k__BackingField
     * @var int
     */
    public $_x003C_IdCompany_x003E_k__BackingField;
    /**
     * The _x003C_IdCustomer_x003E_k__BackingField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $_x003C_IdCustomer_x003E_k__BackingField;
    /**
     * The _x003C_IdPos_x003E_k__BackingField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $_x003C_IdPos_x003E_k__BackingField;
    /**
     * The _x003C_IdUser_x003E_k__BackingField
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var int
     */
    public $_x003C_IdUser_x003E_k__BackingField;
    /**
     * Constructor method for MessageIdentity
     * @uses MessageIdentity::setIdCompany()
     * @uses MessageIdentity::setIdUser()
     * @uses MessageIdentity::setIdPos()
     * @uses MessageIdentity::setIdCustomer()
     * @uses MessageIdentity::set_x003C_IdCompany_x003E_k__BackingField()
     * @uses MessageIdentity::set_x003C_IdCustomer_x003E_k__BackingField()
     * @uses MessageIdentity::set_x003C_IdPos_x003E_k__BackingField()
     * @uses MessageIdentity::set_x003C_IdUser_x003E_k__BackingField()
     * @param int $idCompany
     * @param int $idUser
     * @param int $idPos
     * @param int $idCustomer
     * @param int $_x003C_IdCompany_x003E_k__BackingField
     * @param int $_x003C_IdCustomer_x003E_k__BackingField
     * @param int $_x003C_IdPos_x003E_k__BackingField
     * @param int $_x003C_IdUser_x003E_k__BackingField
     */
    public function __construct($idCompany = null, $idUser = null, $idPos = null, $idCustomer = null, $_x003C_IdCompany_x003E_k__BackingField = null, $_x003C_IdCustomer_x003E_k__BackingField = null, $_x003C_IdPos_x003E_k__BackingField = null, $_x003C_IdUser_x003E_k__BackingField = null)
    {
        $this
            ->setIdCompany($idCompany)
            ->setIdUser($idUser)
            ->setIdPos($idPos)
            ->setIdCustomer($idCustomer)
            ->set_x003C_IdCompany_x003E_k__BackingField($_x003C_IdCompany_x003E_k__BackingField)
            ->set_x003C_IdCustomer_x003E_k__BackingField($_x003C_IdCustomer_x003E_k__BackingField)
            ->set_x003C_IdPos_x003E_k__BackingField($_x003C_IdPos_x003E_k__BackingField)
            ->set_x003C_IdUser_x003E_k__BackingField($_x003C_IdUser_x003E_k__BackingField);
    }
    /**
     * Get IdCompany value
     * @return int
     */
    public function getIdCompany()
    {
        return $this->IdCompany;
    }
    /**
     * Set IdCompany value
     * @param int $idCompany
     * @return \App|C\StructType\MessageIdentity
     */
    public function setIdCompany($idCompany = null)
    {
        // validation for constraint: int
        if (!is_null($idCompany) && !(is_int($idCompany) || ctype_digit($idCompany))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idCompany, true), gettype($idCompany)), __LINE__);
        }
        $this->IdCompany = $idCompany;
        return $this;
    }
    /**
     * Get IdUser value
     * @return int
     */
    public function getIdUser()
    {
        return $this->IdUser;
    }
    /**
     * Set IdUser value
     * @param int $idUser
     * @return \App|C\StructType\MessageIdentity
     */
    public function setIdUser($idUser = null)
    {
        // validation for constraint: int
        if (!is_null($idUser) && !(is_int($idUser) || ctype_digit($idUser))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idUser, true), gettype($idUser)), __LINE__);
        }
        $this->IdUser = $idUser;
        return $this;
    }
    /**
     * Get IdPos value
     * @return int
     */
    public function getIdPos()
    {
        return $this->IdPos;
    }
    /**
     * Set IdPos value
     * @param int $idPos
     * @return \App|C\StructType\MessageIdentity
     */
    public function setIdPos($idPos = null)
    {
        // validation for constraint: int
        if (!is_null($idPos) && !(is_int($idPos) || ctype_digit($idPos))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idPos, true), gettype($idPos)), __LINE__);
        }
        $this->IdPos = $idPos;
        return $this;
    }
    /**
     * Get IdCustomer value
     * @return int
     */
    public function getIdCustomer()
    {
        return $this->IdCustomer;
    }
    /**
     * Set IdCustomer value
     * @param int $idCustomer
     * @return \App|C\StructType\MessageIdentity
     */
    public function setIdCustomer($idCustomer = null)
    {
        // validation for constraint: int
        if (!is_null($idCustomer) && !(is_int($idCustomer) || ctype_digit($idCustomer))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($idCustomer, true), gettype($idCustomer)), __LINE__);
        }
        $this->IdCustomer = $idCustomer;
        return $this;
    }
    /**
     * Get _x003C_IdCompany_x003E_k__BackingField value
     * @return int|null
     */
    public function get_x003C_IdCompany_x003E_k__BackingField()
    {
        return $this->_x003C_IdCompany_x003E_k__BackingField;
    }
    /**
     * Set _x003C_IdCompany_x003E_k__BackingField value
     * @param int $_x003C_IdCompany_x003E_k__BackingField
     * @return \App|C\StructType\MessageIdentity
     */
    public function set_x003C_IdCompany_x003E_k__BackingField($_x003C_IdCompany_x003E_k__BackingField = null)
    {
        // validation for constraint: int
        if (!is_null($_x003C_IdCompany_x003E_k__BackingField) && !(is_int($_x003C_IdCompany_x003E_k__BackingField) || ctype_digit($_x003C_IdCompany_x003E_k__BackingField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_x003C_IdCompany_x003E_k__BackingField, true), gettype($_x003C_IdCompany_x003E_k__BackingField)), __LINE__);
        }
        $this->_x003C_IdCompany_x003E_k__BackingField = $_x003C_IdCompany_x003E_k__BackingField;
        return $this;
    }
    /**
     * Get _x003C_IdCustomer_x003E_k__BackingField value
     * @return int|null
     */
    public function get_x003C_IdCustomer_x003E_k__BackingField()
    {
        return $this->_x003C_IdCustomer_x003E_k__BackingField;
    }
    /**
     * Set _x003C_IdCustomer_x003E_k__BackingField value
     * @param int $_x003C_IdCustomer_x003E_k__BackingField
     * @return \App|C\StructType\MessageIdentity
     */
    public function set_x003C_IdCustomer_x003E_k__BackingField($_x003C_IdCustomer_x003E_k__BackingField = null)
    {
        // validation for constraint: int
        if (!is_null($_x003C_IdCustomer_x003E_k__BackingField) && !(is_int($_x003C_IdCustomer_x003E_k__BackingField) || ctype_digit($_x003C_IdCustomer_x003E_k__BackingField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_x003C_IdCustomer_x003E_k__BackingField, true), gettype($_x003C_IdCustomer_x003E_k__BackingField)), __LINE__);
        }
        $this->_x003C_IdCustomer_x003E_k__BackingField = $_x003C_IdCustomer_x003E_k__BackingField;
        return $this;
    }
    /**
     * Get _x003C_IdPos_x003E_k__BackingField value
     * @return int|null
     */
    public function get_x003C_IdPos_x003E_k__BackingField()
    {
        return $this->_x003C_IdPos_x003E_k__BackingField;
    }
    /**
     * Set _x003C_IdPos_x003E_k__BackingField value
     * @param int $_x003C_IdPos_x003E_k__BackingField
     * @return \App|C\StructType\MessageIdentity
     */
    public function set_x003C_IdPos_x003E_k__BackingField($_x003C_IdPos_x003E_k__BackingField = null)
    {
        // validation for constraint: int
        if (!is_null($_x003C_IdPos_x003E_k__BackingField) && !(is_int($_x003C_IdPos_x003E_k__BackingField) || ctype_digit($_x003C_IdPos_x003E_k__BackingField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_x003C_IdPos_x003E_k__BackingField, true), gettype($_x003C_IdPos_x003E_k__BackingField)), __LINE__);
        }
        $this->_x003C_IdPos_x003E_k__BackingField = $_x003C_IdPos_x003E_k__BackingField;
        return $this;
    }
    /**
     * Get _x003C_IdUser_x003E_k__BackingField value
     * @return int|null
     */
    public function get_x003C_IdUser_x003E_k__BackingField()
    {
        return $this->_x003C_IdUser_x003E_k__BackingField;
    }
    /**
     * Set _x003C_IdUser_x003E_k__BackingField value
     * @param int $_x003C_IdUser_x003E_k__BackingField
     * @return \App|C\StructType\MessageIdentity
     */
    public function set_x003C_IdUser_x003E_k__BackingField($_x003C_IdUser_x003E_k__BackingField = null)
    {
        // validation for constraint: int
        if (!is_null($_x003C_IdUser_x003E_k__BackingField) && !(is_int($_x003C_IdUser_x003E_k__BackingField) || ctype_digit($_x003C_IdUser_x003E_k__BackingField))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($_x003C_IdUser_x003E_k__BackingField, true), gettype($_x003C_IdUser_x003E_k__BackingField)), __LINE__);
        }
        $this->_x003C_IdUser_x003E_k__BackingField = $_x003C_IdUser_x003E_k__BackingField;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\MessageIdentity
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
