<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendTicketConfirmationRequest StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SendTicketConfirmationRequest
 * @subpackage Structs
 */
class SendTicketConfirmationRequest extends AbstractRequest
{
    /**
     * The ToAddress
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ToAddress;
    /**
     * The UniqueID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\UniqueID
     */
    public $UniqueID;
    /**
     * The Verification
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\Verification
     */
    public $Verification;
    /**
     * Constructor method for SendTicketConfirmationRequest
     * @uses SendTicketConfirmationRequest::setToAddress()
     * @uses SendTicketConfirmationRequest::setUniqueID()
     * @uses SendTicketConfirmationRequest::setVerification()
     * @param string $toAddress
     * @param \App|C\StructType\UniqueID $uniqueID
     * @param \App|C\StructType\Verification $verification
     */
    public function __construct($toAddress = null, \App|C\StructType\UniqueID $uniqueID = null, \App|C\StructType\Verification $verification = null)
    {
        $this
            ->setToAddress($toAddress)
            ->setUniqueID($uniqueID)
            ->setVerification($verification);
    }
    /**
     * Get ToAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getToAddress()
    {
        return isset($this->ToAddress) ? $this->ToAddress : null;
    }
    /**
     * Set ToAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $toAddress
     * @return \App|C\StructType\SendTicketConfirmationRequest
     */
    public function setToAddress($toAddress = null)
    {
        // validation for constraint: string
        if (!is_null($toAddress) && !is_string($toAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($toAddress, true), gettype($toAddress)), __LINE__);
        }
        if (is_null($toAddress) || (is_array($toAddress) && empty($toAddress))) {
            unset($this->ToAddress);
        } else {
            $this->ToAddress = $toAddress;
        }
        return $this;
    }
    /**
     * Get UniqueID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\UniqueID|null
     */
    public function getUniqueID()
    {
        return isset($this->UniqueID) ? $this->UniqueID : null;
    }
    /**
     * Set UniqueID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\UniqueID $uniqueID
     * @return \App|C\StructType\SendTicketConfirmationRequest
     */
    public function setUniqueID(\App|C\StructType\UniqueID $uniqueID = null)
    {
        if (is_null($uniqueID) || (is_array($uniqueID) && empty($uniqueID))) {
            unset($this->UniqueID);
        } else {
            $this->UniqueID = $uniqueID;
        }
        return $this;
    }
    /**
     * Get Verification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\Verification|null
     */
    public function getVerification()
    {
        return isset($this->Verification) ? $this->Verification : null;
    }
    /**
     * Set Verification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\Verification $verification
     * @return \App|C\StructType\SendTicketConfirmationRequest
     */
    public function setVerification(\App|C\StructType\Verification $verification = null)
    {
        if (is_null($verification) || (is_array($verification) && empty($verification))) {
            unset($this->Verification);
        } else {
            $this->Verification = $verification;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SendTicketConfirmationRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
