<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SpecialServiceDataFqtv StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:SpecialServiceDataFqtv
 * @subpackage Structs
 */
class SpecialServiceDataFqtv extends ApiObject
{
    /**
     * The AirlineDesignator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AirlineDesignator;
    /**
     * The FrequentFlyerNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FrequentFlyerNumber;
    /**
     * Constructor method for SpecialServiceDataFqtv
     * @uses SpecialServiceDataFqtv::setAirlineDesignator()
     * @uses SpecialServiceDataFqtv::setFrequentFlyerNumber()
     * @param string $airlineDesignator
     * @param string $frequentFlyerNumber
     */
    public function __construct($airlineDesignator = null, $frequentFlyerNumber = null)
    {
        $this
            ->setAirlineDesignator($airlineDesignator)
            ->setFrequentFlyerNumber($frequentFlyerNumber);
    }
    /**
     * Get AirlineDesignator value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAirlineDesignator()
    {
        return isset($this->AirlineDesignator) ? $this->AirlineDesignator : null;
    }
    /**
     * Set AirlineDesignator value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $airlineDesignator
     * @return \App|C\StructType\SpecialServiceDataFqtv
     */
    public function setAirlineDesignator($airlineDesignator = null)
    {
        // validation for constraint: string
        if (!is_null($airlineDesignator) && !is_string($airlineDesignator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airlineDesignator, true), gettype($airlineDesignator)), __LINE__);
        }
        if (is_null($airlineDesignator) || (is_array($airlineDesignator) && empty($airlineDesignator))) {
            unset($this->AirlineDesignator);
        } else {
            $this->AirlineDesignator = $airlineDesignator;
        }
        return $this;
    }
    /**
     * Get FrequentFlyerNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFrequentFlyerNumber()
    {
        return isset($this->FrequentFlyerNumber) ? $this->FrequentFlyerNumber : null;
    }
    /**
     * Set FrequentFlyerNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $frequentFlyerNumber
     * @return \App|C\StructType\SpecialServiceDataFqtv
     */
    public function setFrequentFlyerNumber($frequentFlyerNumber = null)
    {
        // validation for constraint: string
        if (!is_null($frequentFlyerNumber) && !is_string($frequentFlyerNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($frequentFlyerNumber, true), gettype($frequentFlyerNumber)), __LINE__);
        }
        if (is_null($frequentFlyerNumber) || (is_array($frequentFlyerNumber) && empty($frequentFlyerNumber))) {
            unset($this->FrequentFlyerNumber);
        } else {
            $this->FrequentFlyerNumber = $frequentFlyerNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App|C\StructType\SpecialServiceDataFqtv
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
